<?php

require_once("binary.php");

function make_snes_map($map,$til,$fn,$wh,$hh,$bpp,$pal,$pr=false){
   $nt=strlen($til)/(8*$bpp);
   $ly=array(0x00,0x01,0x10,0x11,0x20,0x21,0x30,0x31);
   $tw=$th=8; $r=$bpp;
   if($pr) $m=0x1FFF; else $m=0x3FF;
   $p=0; $o=0; $f_til=str_repeat("\x00",/*strlen($til)<<1*/$nt*$tw*$th);
   while($p<strlen($til)){
      for($y=0;$y<$tw;$y++){
         for($x=0;$x<$th;$x++){
            $a=0;
            for($c=0;$c<$bpp;$c++){
               if(ord($til[$p+($y<<1)+$ly[$c]])&(128>>$x)) $a|=1<<$c;
            }
            $f_til[$o++]=chr($a);
         }
      }
      $p+=8*$bpp;
   }
//   unset($til);
   // create BMP
   $fn_bmp=$fn;
   $bm="";
   $bm.="BM";
   $bm.=int42str(0x436+$wh*$hh*$tw*$th);
   $bm.="\x00\x00\x00\x00";
   $bm.="\x36\x04\x00\x00";
   $bm.="\x28\x00\x00\x00";
   $bm.=int42str($wh*$tw);
   $bm.=int42str($hh*$th);
   $bm.="\x01\x00";
   $bm.="\x08\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.=int42str($wh*$hh*$tw*$th);
   $bm.="\xC4\x0E\x00\x00";
   $bm.="\xC4\x0E\x00\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.=$pal;
   $fl2=$fl1=0; $rr=0;
   $bm.=str_repeat("\x00",$wh*$hh*$tw*$th); $pb=0x436;
   for($s=$hh-1;$s>=0;$s--){
      for($s2=$th-1;$s2>=0;$s2--){
         $p_map=$s*$wh*2;
         for($o=0;$o<$wh;$o++){
            $t=getint2($map,&$p_map);//$map[$s][$o];
            $ti=$t&$m;if($r)$rr=(($t>>10)&7)<<$r;
            if($ti>=$nt) $ti=0; //$rr&=0x3F;
            $fl1=($t&0x4000)?($tw-1):0; $fl2=($t&0x8000)?($th-1):0; //$fl3=$t&0x4000;
            for($o2=0;$o2<$tw;$o2++){
               $bm[$pb++]=$f_til[$ti*$tw*$th+($s2^$fl2)*$tw+($o2^$fl1)]|chr($rr);
            }
         }
      }
   }
   $fp_bmp=fopen($fn_bmp,"wb");
   fwrite($fp_bmp,$bm);
   fclose($fp_bmp);
}

